Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.meta
Class AbstractMetaDataDefaults

    java.lang.Object
      org.apache.openjpa.meta.AbstractMetaDataDefaults

All Implemented Interfaces:
  CallbackModes, MetaDataDefaults

Direct Known Subclasses:
  PersistenceMetaDataDefaults

    public abstract class AbstractMetaDataDefaults

extends Object
implements MetaDataDefaults

Abstract metadata defaults.

Author:
  Abe White

Field Summary

Fields inherited from interface org.apache.openjpa.event.CallbackModes
`CALLBACK_FAIL_FAST, CALLBACK_IGNORE, CALLBACK_LOG, CALLBACK_RETHROW, CALLBACK_ROLLBACK`

Constructor Summary
`AbstractMetaDataDefaults()`

Method Summary
`protected int` | `getAccessType(ClassMetaData meta)` Return the access type of the given metadata.
`Member` | `getBackingMember(FieldMetaData fmd)` Return the backing member for the given field metadata.
`int` | `getCallbackMode()` What to do on lifecycle callback exceptions.
`boolean` | `getCallbacksBeforeListeners(int type)` If callbacks are fired before listeners for the given event type.
`int` | `getDefaultAccessType()` The default access type for base classes with ACCESS_UNKNOWN.
`int` | `getDefaultIdentityType()` The default identity type for unmapped classes without primary key fields.
`protected String` | `getFieldName(Member member)` Return the field name for the given member.
`boolean` | `getIgnoreNonPersistent()`
`Class` | `getUnimplementedExceptionType()` Return a runtime exception class to throw for un-implemented managed interface methods.
`boolean` | `getUsePCRegistry()` Whether to attempt to use the information from registered classes to populate metadata defaults.
`boolean` | `isDeclaredInterfacePersistent()` Whether declared interfaces of a class are treated as persistent types.
`protected abstract boolean` | `isDefaultPersistent(ClassMetaData meta, Member member, String name)` Return true if the given member is persistent by default.
`protected boolean` | `isReservedFieldName(String name)` Returns true if the given field name is reserved for unmanaged fields.
`protected static boolean` | `isUserDefined(Class cls)` Helper method; returns true if the given class appears to be user-defined.
`void` | `populate(ClassMetaData meta, int access)` Populate the given metadata with default settings.
`protected void` | `populate(FieldMetaData fmd)` Populate initial field data.
`void` | `setCallbackMode(int mode)`
`void` | `setCallbackMode(int mode, boolean on)`
`void` | `setDeclaredInterfacePersistent(boolean pers)`
`void` | `setDefaultAccessType(int access)` The default access type for base classes with ACCESS_UNKNOWN.
`void` | `setDefaultIdentityType(int identity)` The default identity type for unmapped classes without primary key fields.
`void` | `setIgnoreNonPersistent(boolean ignore)` Whether to ignore members which are not persistent by default during metadata population.
`void` | `setUsePCRegistry(boolean pcRegistry)` Whether to attempt to use the information from registered classes to populate metadata defaults.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AbstractMetaDataDefaults

    public AbstractMetaDataDefaults()

Method Detail

### getUsePCRegistry

    public boolean getUsePCRegistry()

  Whether to attempt to use the information from registered classes to populate metadata defaults. Defaults to true.

### setUsePCRegistry

    public void setUsePCRegistry(boolean pcRegistry)

  Whether to attempt to use the information from registered classes to populate metadata defaults. Defaults to true.

### getDefaultAccessType

    public int getDefaultAccessType()

  The default access type for base classes with ACCESS_UNKNOWN. ACCESS_FIELD by default.

  Specified by:
    `getDefaultAccessType` in interface `MetaDataDefaults`

### setDefaultAccessType

    public void setDefaultAccessType(int access)

  The default access type for base classes with ACCESS_UNKNOWN. ACCESS_FIELD by default.

### getDefaultIdentityType

    public int getDefaultIdentityType()

  The default identity type for unmapped classes without primary key fields. ID_UNKNOWN by default.

  Specified by:
    `getDefaultIdentityType` in interface `MetaDataDefaults`

### setDefaultIdentityType

    public void setDefaultIdentityType(int identity)

  The default identity type for unmapped classes without primary key fields. ID_UNKNOWN by default.

### getCallbackMode

    public int getCallbackMode()

  Description copied from interface: `MetaDataDefaults`
  What to do on lifecycle callback exceptions.

  Specified by:
    `getCallbackMode` in interface `MetaDataDefaults`

### setCallbackMode

    public void setCallbackMode(int mode)

### setCallbackMode

    public void setCallbackMode(int mode,
                                boolean on)

### getCallbacksBeforeListeners

    public boolean getCallbacksBeforeListeners(int type)

  Description copied from interface: `MetaDataDefaults`
  If callbacks are fired before listeners for the given event type. Defaults to false.

  Specified by:
    `getCallbacksBeforeListeners` in interface `MetaDataDefaults`

### getIgnoreNonPersistent

    public boolean getIgnoreNonPersistent()

### setIgnoreNonPersistent

    public void setIgnoreNonPersistent(boolean ignore)

  Description copied from interface: `MetaDataDefaults`
  Whether to ignore members which are not persistent by default during metadata population. Defaults to true.

  Specified by:
    `setIgnoreNonPersistent` in interface `MetaDataDefaults`

### populate

    public void populate(ClassMetaData meta,
                         int access)

  Description copied from interface: `MetaDataDefaults`
  Populate the given metadata with default settings.

  Specified by:
    `populate` in interface `MetaDataDefaults`
    `access` - access type constant from `ClassMetaData`

### populate

    protected void populate(FieldMetaData fmd)

  Populate initial field data. Does nothing by default.

### getAccessType

    protected int getAccessType(ClassMetaData meta)

  Return the access type of the given metadata. May be a bitwise combination of field and property access constants, or ACCESS_UNKNOWN. Returns ACCESS_FIELD by default.

### getFieldName

    protected String getFieldName(Member member)

  Return the field name for the given member. This will only be invoked on members of the right type (field vs. method). Return null if the member cannot be managed. Default behavior: For fields, returns the field name. For getter methods, returns the minus "get" or "is" with the next letter lower-cased. For other methods, returns null.

### isReservedFieldName

    protected boolean isReservedFieldName(String name)

  Returns true if the given field name is reserved for unmanaged fields.

### isDefaultPersistent

    protected abstract boolean isDefaultPersistent(ClassMetaData meta,
                                                   Member member,
                                                   String name)

  Return true if the given member is persistent by default. This will only be invoked on members of the right type (field vs. method). Returns false if member is static or final by default.

  Parameters:
    `name` - the field name from `getFieldName(java.lang.reflect.Member)`

### setDeclaredInterfacePersistent

    public void setDeclaredInterfacePersistent(boolean pers)

### isDeclaredInterfacePersistent

    public boolean isDeclaredInterfacePersistent()

  Description copied from interface: `MetaDataDefaults`
  Whether declared interfaces of a class are treated as persistent types. Defaults to true.

  Specified by:
    `isDeclaredInterfacePersistent` in interface `MetaDataDefaults`

### getBackingMember

    public Member getBackingMember(FieldMetaData fmd)

  Description copied from interface: `MetaDataDefaults`
  Return the backing member for the given field metadata.

  Specified by:
    `getBackingMember` in interface `MetaDataDefaults`

### getUnimplementedExceptionType

    public Class getUnimplementedExceptionType()

  Description copied from interface: `MetaDataDefaults`
  Return a runtime exception class to throw for un-implemented managed interface methods.

  Specified by:
    `getUnimplementedExceptionType` in interface `MetaDataDefaults`

### isUserDefined

    protected static boolean isUserDefined(Class cls)

  Helper method; returns true if the given class appears to be user-defined.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 Apache Software Foundation. All Rights Reserved.